<template>
    <b-container style="padding: 2%;">
        <b-card title="Escuelas" class="mb-2">
            <b-container class="bv-example-row" fluid="md">
                <b-row align-h="end">
                    <b-col cols="5" md="4"	lg="4"	xl="4">
                        <b-input-group>
                            <b-form-input
                            id="filter-input"
                            v-model="filter"
                            type="search"
                            placeholder="Buscar"
                            ></b-form-input>
                        </b-input-group>
                    </b-col>
                    <b-col cols="6" md="4"	lg="3"	xl="3">
                        <b-button block href="#" variant="primary" v-b-modal.modal-prevent-closing style="padding-bottom: 5px;">Nueva escuela</b-button>
                    </b-col>
                </b-row>
                <b-row>
                    <b-col>
                        <b-card-text>
                            <b-container>
                                <b-row align-v="center">
                                    <b-col align-self="center">
                                        <b-table striped hover :items="items" :fields="fields" :filter="filter">
                                            <template v-slot:cell(students)="row">
                                                <b-button variant="outline-info" @click="$bvModal.show(`modal-scoped${row.item.id}`)" class="mb-2">
                                                    <b-icon icon="person-lines-fill" aria-hidden="true"></b-icon>
                                                </b-button>
                                                <b-modal :id="`modal-scoped${row.item.id}`" @hidden="filterStudents = ''">
                                                    <template v-slot:modal-header>
                                                        <h5>Estudiantes</h5>
                                                    </template>

                                                    <b-container v-if="row.item.students.length != 0">
                                                        <b-row align-h="end">
                                                            <b-col cols="5" md="4"	lg="4"	xl="4">
                                                                <b-input-group>
                                                                    <b-form-input
                                                                    id="filterStudents-input"
                                                                    v-model="filterStudents"
                                                                    type="search"
                                                                    placeholder="Buscar"
                                                                    ></b-form-input>
                                                                </b-input-group>
                                                            </b-col>
                                                        </b-row>
                                                        <div>
                                                            <b-table striped hover :items="row.item.students" :filter="filterStudents" :fields="[{ key: 'name', label: 'Nombre' },{ key: 'lastname', label: 'Apellido' },{ key: 'age', label: 'Edad' }]"></b-table>
                                                        </div>
                                                    </b-container>
                                                    <b-container v-else>
                                                        Esta escuela no posee estudiantes!
                                                    </b-container>

                                                    <template v-slot:modal-footer="{ close }">
                                                        <b-button size="sm" variant="success" @click="close()">Salir</b-button>
                                                    </template>
                                                </b-modal>
                                            </template>

                                            <template v-slot:cell(actions)="row">
                                                <b-button variant="outline-warning" @click="handleEdit(row)" class="mb-2">
                                                    <b-icon icon="pencil-square" aria-hidden="true"></b-icon>
                                                </b-button>
                                                <b-button variant="outline-danger" @click="handleDelete(row)" class="mb-2">
                                                    <b-icon icon="trash" aria-hidden="true"></b-icon>
                                                </b-button>
                                            </template>
                                        </b-table>
                                    </b-col>
                                </b-row>
                            </b-container>
                        </b-card-text>
                    </b-col>
                </b-row>
            </b-container>
        </b-card>

        <!-- Modal Edit -->
        <b-modal :id="infoModal.id" :title="infoModal.title" @hidden="resetModal" @ok="handleOk">
            <form id="modal-edit" ref="formEdit" @submit.stop.prevent="handleSubmit">
                <b-container>
                    <b-row>
                        <input type="hidden" ref="type_form" value="true">
                        <b-col cols="12" md="6">
                            <b-form-group :state="editnameState" label="Escuela" label-for="editname" invalid-feedback="El nombre de la escuela es requerido" >
                                <b-form-input class="sr-only" id="editid" v-model="editid" hidden required ></b-form-input>
                                <b-form-input id="editname" v-model="editname" :state="editnameState" required ></b-form-input>
                            </b-form-group>
                        </b-col>
                    </b-row>
                </b-container>
            </form>
        </b-modal>

        <b-modal id="modal-prevent-closing" ref="modal" title="Nueva escuela" @show="resetModal" @hidden="resetModal" @ok="handleOk">
            <form ref="form" @submit.stop.prevent="handleSubmit">
                <b-container>
                    <b-row>
                        <input type="hidden" ref="type_form" value="false">
                        <b-col cols="12" md="6">
                            <b-form-group :state="nameState" label="Escuela" label-for="name" invalid-feedback="El nombre de la escuela es requerido" >
                                <b-form-input id="name" v-model="name" :state="nameState" required ></b-form-input>
                            </b-form-group>
                        </b-col>
                    </b-row>
                </b-container>
            </form>
        </b-modal>
    </b-container>
</template>

<script>
  export default {
    data() {
      return {
        filter: null,
        filterStudents: null,
        name: '',
        nameState: null,
        stateoptions: [
            { value: null, text: 'Seleccione una opcion' },
            { value: 'bolivar', text: 'bolivar' },
            { value: 'caracas', text: 'caracas' },
            { value: 'anzuategui', text: 'anzuategui' },
        ],
        cityoptions: [
            { value: null, text: 'Seleccione una opcion' },
            { value: 'guayana', text: 'guayana' },
            { value: 'san felix', text: 'san felix' },
            { value: 'area metropolitana', text: 'area metropolitana' },
            { value: 'barcelona', text: 'barcelona' },
        ],

        editid: '',
        editname: '',
        editnameState: null,
        editstateoptions: [
            { value: null, text: 'Seleccione una opcion' },
            { value: 'bolivar', text: 'bolivar' },
            { value: 'caracas', text: 'caracas' },
            { value: 'anzuategui', text: 'anzuategui' },
        ],
        editcityoptions: [
            { value: null, text: 'Seleccione una opcion' },
            { value: 'guayana', text: 'guayana' },
            { value: 'san felix', text: 'san felix' },
            { value: 'area metropolitana', text: 'area metropolitana' },
            { value: 'barcelona', text: 'barcelona' },
        ],


        fields: [
            { key: 'name', label: 'Escuela' },
            { key: 'students', label: 'Estudiantes' },
            { key: 'actions', label: 'Acciones' },
        ],
        items: [],

        infoModal: {
            id: 'info-modal',
            title: '',
            content: ''
        }
      }
    },
    created() {
        this.axios
            .get('http://students.test/api/schools')
            .then(response => {
                this.items = response.data;
            });

    },
    methods: {
        checkFormValidity() {
            if (this.$refs.type_form.value == 'true') {
                const valid = this.$refs.formEdit.checkValidity()
                this.editnameState = (this.editname != '')
                return valid
            } else {
                const valid = this.$refs.form.checkValidity()
                this.nameState = (this.name != '')
                return valid
            }

        },
        resetModal() {
            this.name = ''
            this.nameState = null

            this.editid = ''
            this.editname = ''
            this.editnameState = null

        },
        handleOk(bvModalEvt) {
            // Prevent modal from closing
            bvModalEvt.preventDefault()
            // Trigger submit handler
            this.handleSubmit()
        },
        handleSubmit() {
            // Exit when the form isn't valid
            if (!this.checkFormValidity()) {
                return
            }
            // Push the name to submitted names
            let newItem = {
                name: this.name,
            };

            if (this.$refs.type_form.value == 'true') {
                let editItem = {
                    id: this.editid,
                    name: this.editname,
                };

                this.axios
                .put('http://students.test/api/schools/'+this.editid, editItem)
                .then(response => {
                    this.$set(this.items, this.infoModal.content.index, response.data.school)
                });

                // Hide the modal manually
                this.$nextTick(() => {
                    this.$root.$emit('bv::hide::modal', this.infoModal.id)
                })

            } else {
                let newItem = {
                    name: this.name,
                    state: this.stateselected,
                };
                this.axios
                .post('http://students.test/api/schools', newItem)
                .then(response => {
                    this.items.splice(0, 0, response.data.school);
                });

                // Hide the modal manually
                this.$nextTick(() => {
                    this.$bvModal.hide('modal-prevent-closing')
                })
            }
        },
        handleEdit(row) {
            this.infoModal.title = `Escuelas: ${row.item.name}`
            this.infoModal.content = row
            this.editid = row.item.id
            this.editname = row.item.name
            this.editstateselected = row.item.state
            this.$root.$emit('bv::show::modal', this.infoModal.id)
        },
        handleDelete(row) {
            if (row.item.students.length != 0) {
                this.$bvModal.msgBoxOk('No se puede eliminar, esta escuela posee estudiantes.')
                    .then(value => {})
                    .catch(err => {})
            } else {
                this.$bvModal.msgBoxConfirm('Desea eliminar este cliente?')
                    .then(value => {
                        if (value == true) {
                            this.axios
                                .delete('http://students.test/api/schools/'+row.item.id)
                                .then(response => {
                                    this.items.splice(row.index, 1);
                                });
                        }
                    })
                    .catch(err => {
                    // An error occurred
                    })
            }
        },
    }
  }
</script>

<style>
.modal-header .close {
    padding: 1rem;
    margin: -1rem -1rem -1rem auto;
}
button.close {
    padding: 0;
    background-color: transparent;
    border: 0;
}
.close {
    float: right;
    font-size: 1.5rem;
    font-weight: 700;
    line-height: 1;
    color: #000;
    text-shadow: 0 1px 0 #fff;
    opacity: .5;
}
.modal-backdrop {
    z-index: 1071;
}
.modal-backdrop {
    opacity: .5;
}
.modal-backdrop {
    position: fixed;
    top: 0;
    left: 0;
    z-index: 1040;
    width: 100vw;
    height: 100vh;
    background-color: #000;
}
</style>
